#include "particleID.fxh"
StructuredBuffer<particleID> particles;

RWStructuredBuffer<uint> OutputBuffer : BACKBUFFER;

cbuffer cbSettings : register(b0)
{
	uint elementCount;
}

[numthreads(64,1,1)]
void CS(uint3 tid : SV_DispatchThreadID)
{
	if (tid.x >= elementCount)
		return;
	
	OutputBuffer[tid.x] = particles[tid.x].pID;
}

[numthreads(64,1,1)]
void CScell(uint3 tid : SV_DispatchThreadID)
{
	if (tid.x >= elementCount)
		return;
	
	OutputBuffer[tid.x] = particles[tid.x].cellID;
}

technique11 ParticleID
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}

technique11 CellID
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CScell() ) );
	}
}




