//@author: vux
//@help: template for simple compute shader (buffer write)
//@tags: template
//@credits: 

#include "particleID.fxh"

StructuredBuffer<float3> Particles;
RWStructuredBuffer<particleID> OutputBuffer : BACKBUFFER;

cbuffer cbSettings : register(b0)
{
	uint elementCount;
	uint cellsPerAxis=8;
//	float radius =0.125;
}

uint getFlatIndex(float3 pos){
	int3 cellIndex = floor(pos*cellsPerAxis);
	return cellIndex.z*pow(cellsPerAxis,2)+cellIndex.y*cellsPerAxis+cellIndex.x;
}

[numthreads(64,1,1)]
void CS(uint3 tid : SV_DispatchThreadID)
{
	if (tid.x >= elementCount)
		return;
	
	OutputBuffer[tid.x].pID = tid.x;
	OutputBuffer[tid.x].cellID = getFlatIndex(Particles[tid.x]);
	
}

technique11 Apply
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




