//@author: vux
//@help: template for simple compute shader (buffer write)
//@tags: template
//@credits: 

#include "particleID.fxh"


StructuredBuffer<particleID> ParticleIDs;
RWStructuredBuffer<uint> Counter : COUNTERBUFFER; //prefix sum
RWStructuredBuffer<particleID> ResultBuffer : RESULTBUFFER;

cbuffer cbSettings : register(b0)
{
	uint elementCount;
}


[numthreads(64,1,1)]
void CS(uint3 tid : SV_DispatchThreadID)
{
	if (tid.x >= elementCount)
		return;
		
	particleID partID = ParticleIDs[tid.x];
	uint oldval;
	InterlockedAdd(Counter[partID.cellID],1,oldval);
	ResultBuffer[oldval] = partID;
	
}

technique11 Apply
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




